package com.geocities.cgbusch.hieropreter;
import java.io.*;
import java.util.*;

/**
 * Represents an found entry.
 *
 * @author Chris Busch (cbusch) $Author: cbusch $
 * @since Mon Jan 07 15:27:05 2002
 * @version $Revision: 1.1 $ $Date: 2002/08/03 19:07:32 $
 * @see 
 */


public class DepthListNode implements Comparable {

    int depth=0, start, length, priority=0, score=-1; //dynamic
    Comparable word;
	
    public String toString() {
	return "[d="+depth+" s="+start+" l="+length+" w="+word+" p="+priority+" sc="+score+"]";
    }

    DepthListNode(int s,int len,int p,Comparable w) {
	start=s;
	length=len;
	word=w;
	priority=p;
    }
    
    public Object getObject() { return word; }
    
    public int getStart() { return start; }
    
    public int getLength() { return length; }
    
    public int getEnd() { return start+length-1; }
    
    
    public void setPriority(int p) {
	priority=p;
    }
    
    void setDepth(int dep) {
	depth=dep;
    }
    
    
    /** Returns true if everything is equal except for depth */
    public boolean equals(Object o){
	DepthListNode n=(DepthListNode)o;
	return start==n.start && length==n.length && word.equals(n.word);
    }
    
    int getQuality() {
	return ((Word)word).getQuality();
    }

    public int compareTo(Object o) {
	DepthListNode n=(DepthListNode)o;
	if( score==-1) {
	    score=length*priority*getQuality()-start;
	}
	if( n.score==-1) {
	    n.score=n.length*n.priority*n.getQuality()-n.start;
	}
	int i = start - n.start;
	if( i==0 ) return n.score - score;
	/*
	  int i= n.length-length;
	  if( i==0 ) {
	  i = n.priority-priority;
	  } 
	  if( i==0 ) {
	  i = word.compareTo(n.word);
	  } */
	return i;
    }
    
}
    


