package com.geocities.cgbusch.hieropreter;
import com.geocities.cgbusch.hieropreter.*;
import java.awt.Rectangle;
import java.awt.Point;
import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.JEditorPane;
import java.util.*;

/** Happ: Hieropreter's standalone application
 * <br> All code Copyright 2002 by Chris Busch cgbusch@yahoo.com<p>
 *This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 <p>
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details. <p>
 *
 * @author Chris Busch (cbusch) $Author: cbusch $
 * @since Sep 16 15:27:05 2002
 * @version $Revision: 1.6 $ $Date: 2002/09/19 23:58:55 $
 */
public class Happ extends javax.swing.JFrame {
    
    private CodeMatch cm;

    /** Creates new form Happ */
    public Happ() throws Exception {
        initComponents();
	show();
	getCodeMatch();
	setOutput(MSG);
    }

    private static final String MSG=CodeMatch.TITLE+"<p>Hieropreter interprets Manuel de Codage sequences including Gardiner sign-codes and tries to convert them to English while preserving the Ancient Egyptian word order. (AE word order is: verb subject object abverb.)  This program uses a dictionary of over 40 thousand entries! Hieropreter helps you work with Manual de Codage and Gardiner Codes. You can use '?'s for wild cards and ':' or '-' dashes to delimit Gardiner sign-codes."
	+"\n<p>\n<img src=\"images/codage.gif\">";

    synchronized public CodeMatch getCodeMatch() throws java.io.IOException {
	if( cm==null ) {
	    System.out.println("Loading Dictionary...");
	    outputHtml.setText("Loading Dictionary...");
	    repaint();
	    cm=new CodeMatch(true);
	}
	return cm;
    }

    /** This method is called from within the constructor to
     * initialize the form.
     */
    private void initComponents() {
        main = new javax.swing.JPanel();
        egyptian = new javax.swing.JPanel();
        mdcLabel = new javax.swing.JLabel();
        aeInput = new javax.swing.JTextArea();
        toEnglish = new javax.swing.JButton();
        toGlyphs = new javax.swing.JButton();
        guessLabel = new javax.swing.JLabel();
        guesses = new javax.swing.JTextField();
        logicLabel = new javax.swing.JLabel();
        logicList = new javax.swing.JComboBox(new Object[] 
	    { DepthList.firstFit,
	    DepthList.bigFit,
	    DepthList.topFit,
	    DepthList.straightFit});
        english = new javax.swing.JPanel();
        englishLabel = new javax.swing.JLabel();
        englishInput = new javax.swing.JTextField();
        toEgyptian = new javax.swing.JToggleButton();
        outputScroll = new javax.swing.JScrollPane();
        
        setTitle(CodeMatch.TITLE);
        addWindowListener(new java.awt.event.WindowAdapter() {
		public void windowClosing(java.awt.event.WindowEvent evt) {
		    exitForm(evt);
		}
	    });
        
        main.setLayout(null); 
        
        main.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 1, 1)));
        egyptian.setBorder(new javax.swing.border.TitledBorder("Egyptian Translation"));
        //egyptian.setMaximumSize(new java.awt.Dimension(32767, 103));
        mdcLabel.setText("Manual de Codage phrase with Gardiner Codes:");
        egyptian.add(mdcLabel);
        
        aeInput.setColumns(30);
        aeInput.setRows(6);

	JScrollPane aesp=new JScrollPane();
	aesp.setViewportView(aeInput);
        egyptian.add(aesp);
        
        toEnglish.setText("Egyptian to English");
        toEnglish.addActionListener(new java.awt.event.ActionListener() 
	    {
		public void actionPerformed(java.awt.event.ActionEvent evt) 
		{
		    toEnglishActionPerformed(evt);
		}
	    });
        
        egyptian.add(toEnglish);
        
        toGlyphs.setText("MdC to Hieroglyphs");
        toGlyphs.addActionListener(new java.awt.event.ActionListener() 
	    {
		public void actionPerformed(java.awt.event.ActionEvent evt) 
		{
		    toGlyphsActionPerformed(evt);
		}
	    });
        
        egyptian.add(toGlyphs);
        
        guessLabel.setText("Max Guess:");
        egyptian.add(guessLabel);
        
        guesses.setColumns(2);
        guesses.setText("10");
        egyptian.add(guesses);
        
        logicLabel.setText("Logic:");
        egyptian.add(logicLabel);
        
        logicList.addActionListener(new java.awt.event.ActionListener() 
	    {
		public void actionPerformed(java.awt.event.ActionEvent evt) 
		{
		    logicListActionPerformed(evt);
		}
	    });
        
        egyptian.add(logicList);
        
        main.add(egyptian);
        egyptian.setBounds(10, 0, 440, 220);
        english.setBorder(new javax.swing.border.TitledBorder("English to Egyptian"));
        english.setMaximumSize(new java.awt.Dimension(485, 100));
        englishLabel.setText("One English Word Lookup:");
        english.add(englishLabel);
        
        englishInput.setColumns(15);
        english.add(englishInput);
        
        toEgyptian.setText("English to Egyptian");
        toEgyptian.addActionListener(new 
				     java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) 
		{
		    toEgyptianActionPerformed(evt);
		}
	    });
        
        english.add(toEgyptian);
        
        main.add(english);
	english.setBounds(450, 10, 210, 120);
        
        outputHtml = new JEditorPane("text/html","");
        //outputScroll.getViewport().add(outputHtml);
	outputScroll.setHorizontalScrollBarPolicy(outputScroll.HORIZONTAL_SCROLLBAR_ALWAYS);
	outputScroll.setVerticalScrollBarPolicy(outputScroll.VERTICAL_SCROLLBAR_ALWAYS);

        outputScroll.setViewportView(outputHtml);
        outputScroll.setBorder(new javax.swing.border.TitledBorder("Output")); 

	main.add(outputScroll);
        outputScroll.setBounds( 10, 220, 630, 480-220-10 );
        getContentPane().add(main, java.awt.BorderLayout.CENTER);
        //pack();
        this.setBounds(10,10,1000,600);
	fatten();
    }

    public void fatten() {
	Rectangle r=this.getBounds();
	outputScroll.setBounds(10, 220, r.width-10*2,r.height-220-40);
	outputScroll.repaint();
	//outputScroll.getViewport().scrollRectToVisible(new Rectangle(0,0,1,1));
	outputHtml.getCaret().setDot(0);
	outputScroll.getViewport().setViewPosition(new Point(0,0));
	outputHtml.getCaret().setDot(0);
	repaint();
    }

    protected void setOutput(String msg) {
	try{
	    //System.out.println("<base href=\""+System.getProperties().get("user.dir")+"/\">\n");
	    javax.swing.text.html.HTMLDocument hd=(javax.swing.text.html.HTMLDocument)outputHtml.getDocument();
	    hd.setBase(new File(System.getProperties().get("user.dir").toString()).toURL());
	    outputHtml.setText(msg);
	    aeInput.setText(aeInput.getText());
	    fatten();
	}catch(Throwable t) {
	    outputHtml.setText("Failure:"+t);
	}
    }

    private void toEnglishActionPerformed(java.awt.event.ActionEvent 
					  evt) {
	try{
	    CodeMatch.Flags flags=new CodeMatch.Flags(
						      (Comparator)logicList.getSelectedItem(),
						      true,
						      false
						      );
	    flags.setMaxGuesses(Integer.parseInt(guesses.getText()));
	    String ans=getCodeMatch().translate(aeInput.getText(),flags);
	    setOutput(ans);
	}catch(Throwable t) {
	    setOutput("Failure:"+t);
	}
    }

    private void logicListActionPerformed(java.awt.event.ActionEvent 
					  evt) {
    }

    private void toEgyptianActionPerformed(java.awt.event.ActionEvent 
					   evt) {
	try{
	    StringBuffer sb=new StringBuffer();
	    sb.append("Looking up matches:<p>");
	    Iterator i=getCodeMatch().findByEnglish(englishInput.getText()).iterator();
	    if(! i.hasNext() ) {
		sb.append("No matches found.<p>");
	    }
	    while(i.hasNext()) {
		Word match = (Word)i.next(); 
		sb.append("<table border=1 cellspacing=0><tr><td>"+match.getDefinition()+" "+match.getMdC()+" "+match.getGardiner()+"</td></tr></table><br>");
	    }
	    setOutput(sb.toString());
	}catch(Throwable t) {
	    outputHtml.setText("Failure:"+t);
	}
    }

    private void toGlyphsActionPerformed(java.awt.event.ActionEvent 
					 evt) {
	try{
	    CodeMatch.Flags flags=new CodeMatch.Flags(
						  (Comparator)logicList.getSelectedItem(),
						  false,
						  false
						  );
	    flags.setMaxGuesses(Integer.parseInt(guesses.getText()));
	    String ans=getCodeMatch().translate(aeInput.getText(),flags);
	    setOutput(ans);
	}catch(Throwable t) {
	    outputHtml.setText("Failure:"+t);
	}
    }

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) throws Exception {
	System.err.println(System.getProperties());
        new Happ().show();
    }

    // Variables declaration - do not modify
    private javax.swing.JPanel main;
    private javax.swing.JPanel egyptian;
    private javax.swing.JLabel mdcLabel;
    private javax.swing.JTextArea aeInput;
    private javax.swing.JButton toEnglish;
    private javax.swing.JButton toGlyphs;
    private javax.swing.JLabel guessLabel;
    private javax.swing.JTextField guesses;
    private javax.swing.JLabel logicLabel;
    private javax.swing.JComboBox logicList;
    private javax.swing.JPanel english;
    private javax.swing.JLabel englishLabel;
    private javax.swing.JTextField englishInput;
    private javax.swing.JToggleButton toEgyptian;
    private javax.swing.JEditorPane outputHtml;
    private javax.swing.JScrollPane outputScroll;
    // End of variables declaration

}
