package com.geocities.cgbusch.hieropreter;
import java.io.*;
import java.util.*;

/**
 * A List of SortedMaps of lists, with the outer list being arranged by the length of the words 
 * inner list.
 *
 * <br> All code Copyright 2002 by Chris Busch cgbusch@yahoo.com
 * @author Chris Busch (cbusch) $Author: cbusch $
 * @since Mon Jan 07 15:27:05 2002
 * @version $Revision: 1.3 $ $Date: 2002/09/14 22:48:47 $
 * @see 
 */

public class   WidthContainer {

    
    protected List dictList=new ArrayList();
    
    /**
     * 
     */
    public WidthContainer() {
    }

    SortedMap getDictionary(int wordlength) {
	while(dictList.size()<=wordlength) { 
	    Map m=new TreeMap();
	    dictList.add(m); 
	}
	return (SortedMap)dictList.get(wordlength);
    }

    /** Returns a list of whatever object was originally stored, most likely Word objects. */
    public List lookup(String word) {
	List ret=new ArrayList();
	int len=word.length();
	if( len>getMaxLength()) return ret; //word too long, we won't have it...
	int wildstart=word.indexOf('?');
	if( wildstart>=0 ) {
	    //check to see if all ?s
	    boolean allqs=true;
	    for(int i=0;i<word.length();i++) { 
		if( word.charAt(i)!='?' ) {
		    allqs=false;
		    break;
		}
	    }
	    if( allqs ) return ret; //empty
	    //now lets efficiently find matches
	    SortedMap sm=getDictionary(len);
	    if( wildstart>0) { //restrict range as an index
		String start = word.substring(0,wildstart);
		String stop  = word.substring(0,wildstart-1)
		    +(char)(((char)word.charAt(wildstart-1))+1);
		//System.out.println("Looking from "+start+" "+stop);
		sm=sm.subMap(start,stop);
	    }
	    //look in sm
	    Iterator keys=sm.keySet().iterator();
	    while(keys.hasNext()){
		String o=(String)keys.next();
		if( wildCompare(word,o)) {
		    List list = (List)sm.get(o);
		    ret.addAll(list);
		}
	    }
	}else {
	    List list=(List) getDictionary(len).get(word);
	    if( list != null ) return list;
	}
	return ret;
    }
    
    private boolean wildCompare(String a,String b) {
	for(int i=a.length()-1;i>=0;i--) {
	    char ac=a.charAt(i);
	    char bc=b.charAt(i);
	    if( ac=='?' || bc=='?' ) { 
		//true
	    }else if( ac!=bc ) {
		return false;
	    }
	}
	return true;
    }

    public int getMaxLength() {
	return dictList.size()-1;
    }

    public void add(String key,Object value) {
	List list = (List)getDictionary(key.length()).get(key);
	if( list == null ) {
	    list = new ArrayList();
	    getDictionary(key.length()).put(key,list);
	}
	list.add(value);
    }
    
}
