package com.geocities.cgbusch.hieropreter;
import java.io.*;
import java.util.*;
import java.lang.*;


/**
 * Represents a Dictionary Word.
 *
 * <br> All code Copyright 2002 by Chris Busch cgbusch@yahoo.com
 * @author Chris Busch (cbusch) $Author: cbusch $
 * @since Mon Jan 07 15:27:05 2002
 * @version $Revision: 1.3 $ $Date: 2002/09/14 22:48:47 $
 * @see 
 */

public class  Word implements Comparable {

    private String mdc, gard, type, definition, source, gardimage;

    /**  The quality of this entry. */
    protected int quality=0;
   
    public Word(String mdc,String gard,String type,String definition,String source,int quality){
	this.mdc=mdc.trim();
	this.gard=gard.trim();
	this.type=type.trim();
	this.definition=definition.trim();
	this.source=source.trim();
	this.quality=quality;
    }

    public String getMdC() { return mdc; }

    /** Returns gardiner sequence */
    public String getGardiner() { return gard; }

    public String getType() { return type; }

    public String getDefinition() { return definition; }

    public String getImage() { return gardimage; }

    public int getQuality() {
	return quality;
    }

    /** Only compares the definitions*/
    public boolean equals(Object w) {
	return definition.equalsIgnoreCase(((Word)w).definition);
    }
    
    public int compareTo(Object o) {
	Word w=(Word)o;
	//check quality
	int i = quality - w.quality;
	if( i==0 ) {
	    //longer gard sequence wins
	    i = gard.length() - w.gard.length();
	}
	if( i==0 ) {
	    //longer sequence wins
	    i = mdc.length() - w.mdc.length();
	}
	return -i;
    }

    public String toString() {
	return definition+" <i>"+mdc+"</i> <code>"+gard+"</code><br>";
    }
}
